% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% authors: dimitri.pianeta@gmail.com and Alberto Molano
% version : september 2011
%
% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% Step 1 is to download the toolkit from www.dcm4che.org. Select the
% dcm4che2 tookit 'bin' archive, and unzip it.
%
% Then add the java libraries to your path
% version 3  RT 
%
% Example: 
%  readDcm4che2_2('D:\CHU\stage10\dcm4che2
%  matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\','D:\CHU\stage10\pr
%  ojet original et finale\00000001'')
% 
% 
%pathDcm4che = 'D:\langage
%informatique\dcm4che\dcm4che-2.0.25-bin\dcm4che-2.0.25\lib\';
%testfile = 'C:\Users\Dimitri\Desktop\00000000';
% fileInput : path package java dcm4che2 
% pathDcm4che : path package dcm4che2
% fileInput: noun and path file extension .dcm or no-extension dicom
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function imageFinal = readDcm4che2_3(pathDcm4che,  fileInput )
checkjava = which('org.dcm4che2.io.DicomInputStream');
if isempty(checkjava)
   libpath = pathDcm4che;       
 %libpath = 'D:\CHU\stage10\dcm4che2 matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\';
    javaaddpath([libpath 'dcm4che-core-2.0.25.jar']);
    javaaddpath([libpath 'dcm4che-image-2.0.25.jar']);
    javaaddpath([libpath 'dcm4che-imageio-2.0.25.jar']);
    javaaddpath([libpath 'dcm4che-iod-2.0.25.jar']);
    javaaddpath([libpath 'slf4j-api-1.6.1.jar']);
    javaaddpath([libpath 'slf4j-api-1.6.1.jar']);
    javaaddpath([libpath 'slf4j-log4j12-1.6.1.jar']);
    javaaddpath([libpath 'log4j-1.2.16.jar']);
end

% Now create a reader as follows (other examples on dcm4che wiki)
testfile = [fileInput ];
%testfile = ['C:\Users\Dimitri\Desktop\dfn\S040005'];
dcm = org.dcm4che2.data.BasicDicomObject;
din = org.dcm4che2.io.DicomInputStream(...
    java.io.BufferedInputStream(java.io.FileInputStream(testfile)));
dcm = din.readDicomObject();
disp(dcm);

% You can access the fields like this:

rows = dcm.getInt(org.dcm4che2.data.Tag.Rows);
cols = dcm.getInt(org.dcm4che2.data.Tag.Columns);
pixeldata = dcm.getInts(org.dcm4che2.data.Tag.PixelData);


pixeldata2 = unir_numeros(pixeldata,rows,cols);

img= reshape(pixeldata2 , cols,rows);

 image = zeros(rows,cols);
 for i =1 :rows-1
     for j=1 :cols-1
  image(i, j)= img(cols-j,i);
     end
 end

imageFinal=image(1:rows,cols:-1:1);

% figure(1);
 imshow(imageFinal,[]);
% title('Picture original');

function pixeldata2 = unir_numeros(pixeldata, rows, cols)
pixeldata2 = zeros(rows*cols, 1);
fin = rows*cols*2;
cont = 0;
for i = 1:2:fin
    A = pixeldata(i);
    B = pixeldata(i+1);
    cont = cont + 1;
    pixeldata2(cont,1) = A + B*65535;
end

