%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Transformation matrice Tag.PixelData with change Tag.Rows and Tag.Lows
% --> Output Path + noun fileOutput 
%
% authors: dimitri.pianeta@gmail.com
% version : may 2010
%
% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% Step 1 is to download the toolkit from www.dcm4che.org. Select the
% dcm4che2 tookit 'bin' archive, and unzip it.
%
% Then add the java libraries to your path
%
% Example: 
% pathDcm4che = 'D:\CHU\stage10\dcm4che2 matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\'
% image: matrice 
% fileInput = 'D:\CHU\stage10\projet original et finale\00000001';
% pathOutput = 'C:\Users\Dimitri\Desktop\final2';
% fileOutput = 'essai.dcm';
% 
% @param: 
% pathDcm4che : path package java dcm4che2 
% fileInput: noun and path file extension .dcm or no-extension dicom
% pathOutput : path file output
% fileOutput: noun file output
% image : new pixel matrice  
% 
%
% @ version : 4
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  output_args  = writenMatrice3(pathDcm4che ,image, fileInput,  pathOutput, fileOutput, nameMethod  )

%   Detailed explanation goes here

checkjava = which('org.dcm4che2.io.DicomInputStream');
if isempty(checkjava)
    %libpath = 'D:\CHU\stage10\dcm4che2
    %matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\';s
    libpath = pathDcm4che; %'D:\CHU\stage10\dcm4che2 matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\'
    javaaddpath([libpath 'dcm4che-core-2.0.27.jar']);
    javaaddpath([libpath 'dcm4che-image-2.0.27.jar']);
    javaaddpath([libpath 'dcm4che-imageio-2.0.27.jar']);
    javaaddpath([libpath 'dcm4che-iod-2.0.27.jar']);
    javaaddpath([libpath 'dcm4che-filecache-2.0.27.jar']);
    javaaddpath([libpath 'dcm4che-net-2.0.27.jar'])
    
    javaaddpath([libpath 'slf4j-api-1.6.1.jar']);
    javaaddpath([libpath 'slf4j-api-1.6.1.jar']);
    javaaddpath([libpath 'slf4j-log4j12-1.6.1.jar']);
    javaaddpath([libpath 'log4j-1.2.16.jar']);
 end

% Now create a reader as follows (other examples on dcm4che2 wiki)

testfile = fileInput;

dcm = org.dcm4che2.data.BasicDicomObject;
din = org.dcm4che2.io.DicomInputStream(...
    java.io.BufferedInputStream(java.io.FileInputStream(testfile)));
dcm = din.readDicomObject();%dicomObject


%fileOutput 

testFile2 = [pathOutput '\'  fileOutput];
 
rows = size(image,1);%give rows image
cols = size(image,2);%give ligne image
  
img = zeros(cols,rows);
for i =1 :rows-1
    for j=1 :cols-1
% img(rows-j, i)= image(i,j);
 img(j, i)=image(i,cols-j);
    end
end

%imageFinale =  img(rows:-1:1,1:1:cols);%Change matrice 
imageFinale =  img( cols:-1:1,1:1:rows);%Change matrice 
img = reshape(imageFinale, 1, rows*cols);%Reshape array

 
%%%%%
dcm.putInts(org.dcm4che2.data.Tag.PixelData, dcm.vrOf(org.dcm4che2.data.Tag.PixelData),img)%Tag.PixelData
dcm.putString(org.dcm4che2.data.Tag.Rows, dcm.vrOf(org.dcm4che2.data.Tag.Rows),int2str(rows)); %Tag.Rows
dcm.putString(org.dcm4che2.data.Tag.Columns, dcm.vrOf(org.dcm4che2.data.Tag.Columns),int2str(cols));%Tag.Cols
dcm.putString(org.dcm4che2.data.Tag.PatientName,dcm.vrOf(org.dcm4che2.data.Tag.PatientName),nameMethod);


dos =org.dcm4che2.io.DicomOutputStream(...
                    java.io.BufferedOutputStream(java.io.FileOutputStream(testFile2)));	%BufferedOutput	     
				 dos.writeDicomFile(dcm); %written file dicom
				 dos.close(); %close file